import { Nullable, Undefinable } from 'tsdef';
import { ChonkyIconName } from './icons.types';
export interface FileData {
    id: string;
    name: string;
    ext?: string;
    isDir?: boolean;
    isHidden?: boolean;
    isSymlink?: boolean;
    isEncrypted?: boolean;
    openable?: boolean;
    selectable?: boolean;
    draggable?: boolean;
    droppable?: boolean;
    dndOpenable?: boolean;
    size?: number;
    modDate?: Date | string;
    childrenCount?: number;
    color?: string;
    icon?: ChonkyIconName | string | any;
    thumbnailUrl?: string;
    folderChainIcon?: Nullable<ChonkyIconName | string | any>;
    guid?: string;
    originalName?: string;
    friendlyName?: string;
    description?: string;
    dateAdded?: string;
    fileType?: FileTypeEnum;
    isObsolete?: boolean;
    categoryList?: IFileListItemCategory[];
    assignmentList?: IFileListItemCategoryAssignment[];
}
export declare type FileArray = Nullable<FileData>[];
export declare type FileFilter = (file: Nullable<FileData>) => boolean;
export declare type FileMap = {
    [fileId: string]: FileData;
};
export declare type FileIdTrueMap = {
    [fileId: string]: Undefinable<true>;
};
export interface IFileListItemCategory {
    id: number;
    name: string;
}
export interface IFileListItemCategoryAssignment {
    id: number;
    name: string;
    objectType?: string;
}
export declare enum FileTypeEnum {
    Jpeg = 1,
    Movie = 2,
    Word = 3,
    Pdf = 4,
    Xlsx = 5,
    Json = 6
}
