import { Theme as MuiTheme } from '@material-ui/core/styles';
import { Styles } from 'jss';
import { DeepPartial } from 'tsdef';
export declare const lightTheme: (theme?: MuiTheme | undefined) => ChonkyTheme;
export declare type ChonkyTheme = {
    colors: {
        debugRed: string | number;
        debugBlue: string | number;
        debugGreen: string | number;
        debugPurple: string | number;
        debugYellow: string | number;
        textActive: string | number;
    };
    fontSizes: {
        rootPrimary: string | number;
    };
    margins: {
        rootLayoutMargin: string | number;
    };
    toolbar: {
        size: number;
        lineHeight: string | number;
        fontSize: string | number;
        buttonRadius: string | number;
    };
    dnd: {
        canDropColor: string;
        cannotDropColor: string;
        canDropMask: string;
        cannotDropMask: string;
        fileListCanDropMaskOne: string;
        fileListCanDropMaskTwo: string;
        fileListCannotDropMaskOne: string;
        fileListCannotDropMaskTwo: string;
    };
    dragLayer: {
        border: string | number;
        padding: string | number;
        borderRadius: string | number;
    };
    fileList: {
        desktopGridGutter: string | number;
        mobileGridGutter: string | number;
    };
    gridFileEntry: {
        childrenCountSize: string | number;
        iconColorFocused: string | number;
        iconSize: string | number;
        iconColor: string | number;
        borderRadius: string | number;
        fontSize: string | number;
        fileColorTint: string;
        folderBackColorTint: string;
        folderFrontColorTint: string;
    };
    listFileEntry: {
        propertyFontSize: number;
        iconFontSize: string | number;
        iconBorderRadius: number;
        fontSize: number;
    };
};
export declare const darkThemeOverride: DeepPartial<ChonkyTheme>;
export declare const mobileThemeOverride: DeepPartial<ChonkyTheme>;
export declare const useIsMobileBreakpoint: () => boolean;
export declare const getStripeGradient: (colorOne: string, colorTwo: string) => string;
export declare const makeLocalChonkyStyles: <C extends string = string>(styles: (theme: ChonkyTheme & MuiTheme) => Styles<C>) => (data?: unknown) => import("jss").Classes<C>;
export declare const makeGlobalChonkyStyles: <C extends string = string>(makeStyles: (theme: ChonkyTheme & MuiTheme) => Styles<C>) => (...args: any[]) => import("jss").Classes<C>;
export declare const important: <T>(value: T) => (string | T)[];
export declare const c: import("classnames/types").ClassNamesExport;
